#include <bits/stdc++.h>
using namespace std;

#define N 200001
const long long mod = 10e9 + 7;
long long a[N];
long long dp[N];

long long rek(int l, int r, int k) {
    if (k == 0) {
        return dp[r] - dp[l - 1];
    }
    long long resenje = 0;
    for (int i = l; i <= r; i++) {
        for (int j = i; j <= r; j++) {
            resenje += rek(i, j, k - 1);
            resenje %= mod;
        }
    }
    return resenje;
}

void solve() {
    long long n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        dp[i + 1] = dp[i] + a[i];
    }
    cout << rek(1, n, k);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    solve();
    return 0;
}